# Operator - Sign PYTH-SPL Transaction

## Requirements

* Online machine

* [Operator PGP key pairs](../../key-types.md#operator-pgp-keypair) 

{{ #include ../../../../operator-requirements.md:requirements }}

## Procedure

1. Verify all transactions for the ceremony in the `ceremonies` repository, ensuring that all the transactions are properly signed by the proposer and the approver using PGP keys which have been checked into ceremonies repository.

1. Copy the transactions and signatures to an SD card

1. Enter the designated location with the quorum of operators and all required equipment

1. Lock access to the location - there should be no inflow or outflow of people during the ceremony

1. Retrieve sealed Air-Gapped bundle and polaroid from locked storage

### Unsealing Tamper Proofing

{{ #include ../../../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-unsealing}}

### Ceremony

1. Turn on online machine

1. Once booted, run `icepick workflow sol broadcast --nonce-address=<nonce_address>` command

    - [ ] TODO find a place for the nonce_address in the ceremony repo

    * Plug in "Transaction" SD card

    * Await completion message before removing "Transaction" SD card

    * This command will set the computer into "awaiting mode", which will broadcast the signed transaction from the SD card once it's plugged back in

1. Plug in SD card labelled "AirgapOS" into the air-gapped machine

1. Boot the computer  

1. Unplug the "AirgapOS" SD card

1. Plug in SD card labelled "Keychain"

    * Load well known PGP keys of proposer and approver 
        * `gpg --import <keyfile_name>`
    
1. Use detached signatures of the keys on the SD cards to verify the pub certs 

    - [ ] write bash script that for each pub cert, looks for 2 detached sigs made by two other certs

1. Unplug the "Keychain" SD card

1. Insert SD card labelled "Shardfile"

1. [ ] in root entropy ceremony add step to write an autorun.sh script to shardfile sd card that runs `keyfork recover shard --daemon`

    * Follow on screen prompts

1. Unplug SD card labelled "Shardfile"

1. Plug in the "Transaction" SD card

1. For each transaction, verify that the signature is made by trusted keys that are loaded in the gpg keyring:

    * `gpg --verify <detached_signature>`

    - [ ] todo write a script for this

1. Run the `icepick` command with the transaction payload

    * `icepick workflow sol transfer-token --input-file=<payload.json>` 

    * Follow on screen prompts

1. Unplug the "Transaction" SD card

### Broadcast Transaction

1. Plug the "Transaction" SD card into online machine

1. The still running broadcast command on the online machine will broadcast the transaction automatically

1. The url that's found in the response after a successful broadcast should be reviewed and committed to the ceremony repository

### Finalization

1. Shut down online machine

1. Shut down the air gapped machine

#### Sealing

1. Gather all the original items that were in the air-gapped bundle:

    * Air-gapped computer

    * AirgapOS SD card

    * Shardfile SD card

    * Keychain SD card

{{ #include ../../../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-sealing}}

